# $Id: template,v 0.3.2.1 2002/09/12 11:00:00 robert Exp $
#
# (c) 2002 by Pengutronix e.K., Hildesheim, Germany
# See CREDITS for details about who has contributed to this project. 
#
# For further information about the PTXDIST project and license conditions
# see the README file.
#

#
# We provide this package
#
ifeq (y,$(PTXCONF_ZLIB))
PACKAGES += zlib
endif

#
# Paths and names 
#
ZLIB			= zlib-1.1.4
ZLIB_URL 		= ftp://ftp.info-zip.org/pub/infozip/zlib/$(ZLIB).tar.gz
ZLIB_SOURCE		= $(SRCDIR)/$(ZLIB).tar.gz
ZLIB_DIR 		= $(BUILDDIR)/$(ZLIB)
ZLIB_EXTRACT		= gzip -dc

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

zlib_get: $(STATEDIR)/zlib.get

$(STATEDIR)/zlib.get: $(ZLIB_SOURCE)
	touch $@

$(ZLIB_SOURCE):
	@echo
	@echo --------
	@echo target: zlib.get
	@echo --------
	@echo
	wget -P $(SRCDIR) $(PASSIVEFTP) $(ZLIB_URL)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

zlib_extract: $(STATEDIR)/zlib.extract

$(STATEDIR)/zlib.extract: $(STATEDIR)/zlib.get
	@echo
	@echo ------------
	@echo target: zlib.extract
	@echo ------------
	@echo
	$(ZLIB_EXTRACT) $(ZLIB_SOURCE) | $(TAR) -C $(BUILDDIR) -xf -
	touch $@

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

zlib_prepare: $(STATEDIR)/zlib.prepare

ZLIB_AUTOCONF =
ZLIB_AUTOCONF += --shared
ZLIB_AUTOCONF += --prefix=$(PTXCONF_PREFIX)

$(STATEDIR)/zlib.prepare: $(STATEDIR)/zlib.extract
	@echo
	@echo ------------
	@echo target: zlib.prepare
	@echo ------------
	@echo
	# FIXME: this does currently not work with the local toolchain
	cd $(ZLIB_DIR) && 						\
	./configure $(ZLIB_AUTOCONF)
	perl -i -p -e 's/gcc/$(PTXCONF_GNU_TARGET)-gcc/g' $(ZLIB_DIR)/Makefile
	touch $@

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

zlib_compile: $(STATEDIR)/zlib.compile

$(STATEDIR)/zlib.compile: $(STATEDIR)/zlib.prepare 
	@echo
	@echo ----------------------- 
	@echo target: zlib.compile
	@echo -----------------------
	@echo
	cd $(ZLIB_DIR) && PATH=$(PTXCONF_PREFIX)/bin:$$PATH make CC=$(PTXCONF_GNU_TARGET)-gcc
	touch $@

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

zlib_install: $(STATEDIR)/zlib.install

$(STATEDIR)/zlib.install: $(STATEDIR)/zlib.compile
	@echo
	@echo ----------------------- 
	@echo target: zlib.install
	@echo -----------------------
	@echo
	PATH=$(PTXCONF_PREFIX)/bin:$$PATH make -C $(ZLIB_DIR) install PREFIX=$(PTXCONF_PREFIX)
	touch $@

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

zlib_targetinstall: $(STATEDIR)/zlib.targetinstall

$(STATEDIR)/zlib.targetinstall: $(STATEDIR)/zlib.install
	@echo
	@echo ------------------ 
	@echo target: zlib.targetinstall
	@echo ------------------
	@echo
	# FIXME: can we replace this with install?
	cp -d $(PTXCONF_PREFIX)/lib/libz.so* $(ROOTDIR)/lib
	strip $(ROOTDIR)/lib/libz.so*
	touch $@

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

zlib_clean: 
	rm -rf $(STATEDIR)/zlib.* $(ZLIB_DIR)

# vim: syntax=make
